Index: kern/kern_proc.c
===================================================================
RCS file: /cvs/OpenBSD/src/sys/kern/kern_proc.c,v
retrieving revision 1.36
retrieving revision 1.36.6.12
diff -u -r1.36 -r1.36.6.12
--- kern/kern_proc.c	10 Oct 2007 15:53:53 -0000	1.36
+++ kern/kern_proc.c	18 Feb 2009 12:43:25 -0000	1.36.6.12
@@ -49,20 +49,18 @@
 #include <sys/signalvar.h>
 #include <sys/pool.h>
 
+
+#ifdef GLOBAL_HASH
+struct pidhhead	*pidhashtbl;
+u_long		 pidhash;
+struct pghhead	*pgrphashtbl;
+u_long		 pgrphash;
+#endif
+
 #define	UIHASH(uid)	(&uihashtbl[(uid) & uihash])
 LIST_HEAD(uihashhead, uidinfo) *uihashtbl;
 u_long uihash;		/* size of hash table - 1 */
 
-/*
- * Other process lists
- */
-struct pidhashhead *pidhashtbl;
-u_long pidhash;
-struct pgrphashhead *pgrphashtbl;
-u_long pgrphash;
-struct proclist allproc;
-struct proclist zombproc;
-
 struct pool proc_pool;
 struct pool process_pool;
 struct pool rusage_pool;
@@ -70,11 +68,9 @@
 struct pool pgrp_pool;
 struct pool session_pool;
 struct pool pcred_pool;
+struct pool instproc_pool;
 
 static void orphanpg(struct pgrp *);
-#ifdef DEBUG
-void pgrpdump(void);
-#endif
 
 /*
  * Initialize global process hashing structures.
@@ -82,16 +78,21 @@
 void
 procinit(void)
 {
-	LIST_INIT(&allproc);
-	LIST_INIT(&zombproc);
-
-
-	pidhashtbl = hashinit(maxproc / 4, M_PROC, M_NOWAIT, &pidhash);
-	pgrphashtbl = hashinit(maxproc / 4, M_PROC, M_NOWAIT, &pgrphash);
 	uihashtbl = hashinit(maxproc / 16, M_PROC, M_NOWAIT, &uihash);
-	if (!pidhashtbl || !pgrphashtbl || !uihashtbl)
+	if (!uihashtbl)
 		panic("procinit: malloc");
 
+#ifdef GLOBAL_HASH
+	pidhash = 0;
+	pgrphash = 0;
+	pidhashtbl = hashinit
+		(maxproc / 4, M_PROC, M_WAITOK, &pidhash);
+	pgrphashtbl = hashinit
+		(maxproc / 4, M_PROC, M_NOWAIT, &pgrphash);
+#endif
+
+	pool_init(&instproc_pool, sizeof(struct inst_proc), 0, 0, 0, 
+			"instprocpl", &pool_allocator_nointr);
 	pool_init(&proc_pool, sizeof(struct proc), 0, 0, 0, "procpl",
 	    &pool_allocator_nointr);
 	pool_init(&process_pool, sizeof(struct process), 0, 0, 0, "processpl",
@@ -108,6 +109,91 @@
 	    &pool_allocator_nointr);
 }
 
+
+struct inst_proc *
+proc_instinit(const struct inst *inst)
+{
+	struct inst_proc *p;
+
+	KASSERT(inst);
+
+	p = pool_get(&instproc_pool, PR_WAITOK|PR_ZERO);
+
+	LIST_INIT(&p->allproc);
+	LIST_INIT(&p->zombproc);
+
+#ifndef GLOBAL_HASH
+	p->pidhash = 0;
+	p->pgrphash = 0;
+
+	p->pidhashtbl = hashinit
+		(maxproc / 4, M_PROC, M_WAITOK, &p->pidhash);
+	p->pgrphashtbl = hashinit
+		(maxproc / 4, M_PROC, M_NOWAIT, &p->pgrphash);
+#else
+	p->instid = inst->inst_id;
+#endif
+
+	return(p);
+}
+
+
+void
+proc_instfree(struct inst_proc *p)
+{
+
+	KASSERT(p);
+	KASSERT(LIST_EMPTY(&p->allproc));
+
+#ifndef GLOBAL_HASH
+	if (p->pidhashtbl) 
+		free(p->pidhashtbl, M_PROC);
+	if (p->pgrphashtbl) 
+		free(p->pgrphashtbl, M_PROC);
+#endif
+}
+
+
+void
+proc_instadd(struct inst_proc *p, struct proc *proc)
+{
+
+	KASSERT(p);
+	KASSERT(proc);
+	KASSERT(proc->p_inst->inst_proc == p);
+	/*
+	 * Insert us into the pid hashtable and the list of all
+	 * processes.
+	 */
+
+#ifdef GLOBAL_HASH
+	LIST_INSERT_HEAD(&pidhashtbl[proc->p_pid & pidhash],
+			proc, p_hash);
+#else
+	LIST_INSERT_HEAD(&p->pidhashtbl[proc->p_pid & p->pidhash],
+			proc, p_hash);
+#endif
+
+	LIST_INSERT_HEAD(&p->allproc, proc, p_list);
+}
+
+
+void
+pgrp_instadd(struct inst_proc *p, struct pgrp *pgrp)
+{
+	KASSERT(p);
+	KASSERT(pgrp);
+
+#ifdef GLOBAL_HASH
+	LIST_INSERT_HEAD(&pgrphashtbl[pgrp->pg_id & pgrphash],
+			pgrp, pg_hash);
+#else
+	LIST_INSERT_HEAD(&p->pgrphashtbl[pgrp->pg_id & p->pgrphash],
+			pgrp, pg_hash);
+#endif
+}
+
+
 /*
  * Change the count associated with number of processes
  * a given user is using.
@@ -158,22 +244,31 @@
 {
 
 	for (; p != curproc; p = p->p_pptr)
-		if (p->p_pid == 0)
+		if (NULL == p || p->p_pid == 0)
 			return (0);
 	return (1);
 }
 
-/*
- * Locate a process by number
- */
+
 struct proc *
-pfind(pid_t pid)
+pfind(struct inst_proc *ip, pid_t pid)
 {
 	struct proc *p;
 
-	LIST_FOREACH(p, PIDHASH(pid), p_hash)
+	KASSERT(ip);
+
+#ifdef GLOBAL_HASH
+	LIST_FOREACH(p, &pidhashtbl[pid & pidhash], p_hash)
+		if (p->p_pid == pid && p->p_inst->inst_id == ip->instid)
+			return (p);
+		else if (p->p_pid == pid)
+			return (NULL);
+#else
+	LIST_FOREACH(p, &ip->pidhashtbl[pid & ip->pidhash], p_hash)
 		if (p->p_pid == pid)
 			return (p);
+#endif
+
 	return (NULL);
 }
 
@@ -181,13 +276,23 @@
  * Locate a process group by number
  */
 struct pgrp *
-pgfind(pid_t pgid)
+pgfind(struct inst_proc *ip, pid_t pgid)
 {
 	struct pgrp *pgrp;
 
-	LIST_FOREACH(pgrp, PGRPHASH(pgid), pg_hash)
+	KASSERT(ip);
+
+#ifdef GLOBAL_HASH
+	LIST_FOREACH(pgrp, &pgrphashtbl[pgid & pgrphash], pg_hash)
+		if (pgrp->pg_id == pgid && pgrp->pg_inst->inst_id == ip->instid)
+			return (pgrp);
+		else if (pgrp->pg_id == pgid)
+			return (NULL);
+#else
+	LIST_FOREACH(pgrp, &ip->pgrphashtbl[pgid & ip->pgrphash], pg_hash)
 		if (pgrp->pg_id == pgid)
 			return (pgrp);
+#endif
 	return (NULL);
 }
 
@@ -197,7 +302,10 @@
 int
 enterpgrp(struct proc *p, pid_t pgid, int mksess)
 {
-	struct pgrp *pgrp = pgfind(pgid);
+	struct pgrp *pgrp;
+
+	KASSERT(p->p_inst);
+	pgrp = pgfind(p->p_inst->inst_proc, pgid);
 
 #ifdef DIAGNOSTIC
 	if (pgrp != NULL && mksess)	/* firewalls */
@@ -215,7 +323,7 @@
 		if (p->p_pid != pgid)
 			panic("enterpgrp: new pgrp and pid != pgid");
 #endif
-		if ((np = pfind(savepid)) == NULL || np != p)
+		if ((np = pfind(p->p_inst->inst_proc, savepid)) == NULL || np != p)
 			return (ESRCH);
 		pgrp = pool_get(&pgrp_pool, PR_WAITOK);
 		if (mksess) {
@@ -229,21 +337,28 @@
 			sess->s_count = 1;
 			sess->s_ttyvp = NULL;
 			sess->s_ttyp = NULL;
+			KASSERT(p->p_session);
 			bcopy(p->p_session->s_login, sess->s_login,
 			    sizeof(sess->s_login));
 			atomic_clearbits_int(&p->p_flag, P_CONTROLT);
 			pgrp->pg_session = sess;
+#if 0
 #ifdef DIAGNOSTIC
 			if (p != curproc)
 				panic("enterpgrp: mksession and p != curproc");
 #endif
+#endif
 		} else {
+			KASSERT(p->p_session);
 			pgrp->pg_session = p->p_session;
 			pgrp->pg_session->s_count++;
 		}
 		pgrp->pg_id = pgid;
 		LIST_INIT(&pgrp->pg_members);
-		LIST_INSERT_HEAD(PGRPHASH(pgid), pgrp, pg_hash);
+		pgrp_instadd(p->p_inst->inst_proc, pgrp);
+#ifdef GLOBAL_HASH
+		pgrp->pg_inst = p->p_inst;
+#endif
 		pgrp->pg_jobc = 0;
 	} else if (pgrp == p->p_pgrp)
 		return (0);
@@ -271,6 +386,7 @@
 leavepgrp(struct proc *p)
 {
 
+	KASSERT(p->p_pgrp);
 	LIST_REMOVE(p, p_pglist);
 	if (LIST_EMPTY(&p->p_pgrp->pg_members))
 		pgdelete(p->p_pgrp);
@@ -285,6 +401,8 @@
 pgdelete(struct pgrp *pgrp)
 {
 
+	KASSERT(pgrp);
+	KASSERT(pgrp->pg_session);
 	if (pgrp->pg_session->s_ttyp != NULL && 
 	    pgrp->pg_session->s_ttyp->t_pgrp == pgrp)
 		pgrp->pg_session->s_ttyp->t_pgrp = NULL;
@@ -307,14 +425,20 @@
 fixjobc(struct proc *p, struct pgrp *pgrp, int entering)
 {
 	struct pgrp *hispgrp;
-	struct session *mysession = pgrp->pg_session;
+	struct session *mysession;
+
+	KASSERT(pgrp);
+	KASSERT(p);
+
+	mysession = pgrp->pg_session;
 
 	/*
 	 * Check p's parent to see whether p qualifies its own process
 	 * group; if so, adjust count for p's process group.
 	 */
-	if ((hispgrp = p->p_pptr->p_pgrp) != pgrp &&
-	    hispgrp->pg_session == mysession) {
+	if (NULL == p->p_pptr || 
+			((hispgrp = p->p_pptr->p_pgrp) != pgrp && 
+			 hispgrp->pg_session == mysession)) {
 		if (entering)
 			pgrp->pg_jobc++;
 		else if (--pgrp->pg_jobc == 0)
@@ -330,6 +454,7 @@
 		if ((hispgrp = p->p_pgrp) != pgrp &&
 		    hispgrp->pg_session == mysession &&
 		    P_ZOMBIE(p) == 0) {
+			KASSERT(hispgrp);
 			if (entering)
 				hispgrp->pg_jobc++;
 			else if (--hispgrp->pg_jobc == 0)
@@ -396,6 +521,7 @@
 db_show_all_procs(db_expr_t addr, int haddr, db_expr_t count, char *modif)
 {
 	char *mode;
+	struct inst *i;
 	int doingzomb = 0;
 	struct proc *p, *pp;
     
@@ -413,87 +539,92 @@
 		return;
 	}
 	
-	p = LIST_FIRST(&allproc);
 
 	switch (*mode) {
-
 	case 'a':
-		db_printf("   PID  %-10s  %18s  %18s  %18s\n",
+		db_printf("   PID  %10s  %-10s  %18s  %18s  %18s\n",
 		    "COMMAND", "STRUCT PROC *", "UAREA *", "VMSPACE/VM_MAP");
 		break;
 	case 'n':
-		db_printf("   PID  %5s  %5s  %5s  S  %10s  %-12s  %-16s\n",
+		db_printf("   PID  %10s  %5s  %5s  %5s  S  %10s  %-12s  %-16s\n",
 		    "PPID", "PGRP", "UID", "FLAGS", "WAIT", "COMMAND");
 		break;
 	case 'w':
-		db_printf("   PID  %-16s  %-8s  %18s  %s\n",
+		db_printf("   PID  %10s  %-16s  %-8s  %18s  %s\n",
 		    "COMMAND", "EMUL", "WAIT-CHANNEL", "WAIT-MSG");
 		break;
 	}
 
-	while (p != 0) {
-		pp = p->p_pptr;
-		if (p->p_stat) {
-
-			db_printf("%c%5d  ", p == curproc ? '*' : ' ',
-				p->p_pid);
-
-			switch (*mode) {
-
-			case 'a':
-				db_printf("%-10.10s  %18p  %18p  %18p\n",
-				    p->p_comm, p, p->p_addr, p->p_vmspace);
-				break;
-
-			case 'n':
-				db_printf("%5d  %5d  %5d  %d  %#10x  "
-				    "%-12.12s  %-16s\n",
-				    pp ? pp->p_pid : -1, p->p_pgrp->pg_id,
-				    p->p_cred->p_ruid, p->p_stat, p->p_flag,
-				    (p->p_wchan && p->p_wmesg) ?
-					p->p_wmesg : "", p->p_comm);
-				break;
-
-			case 'w':
-				db_printf("%-16s  %-8s  %18p  %s\n", p->p_comm,
-				    p->p_emul->e_name, p->p_wchan,
-				    (p->p_wchan && p->p_wmesg) ? 
-					p->p_wmesg : "");
-				break;
+	LIST_FOREACH(i, &inst_all, inst_list) {
+		p = LIST_FIRST(&i->inst_proc->allproc);
+	
+		while (p != 0) {
+			pp = p->p_pptr;
+			if (p->p_stat) {
+	
+				db_printf("%c%5d  %10x  ", p == curproc ? '*' : ' ',
+					p->p_pid, p->p_inst->inst_id);
 
+				switch (*mode) {
+	
+				case 'a':
+					db_printf("%-10.10s  %18p  %18p  %18p\n",
+					    p->p_comm, p, p->p_addr, p->p_vmspace);
+					break;
+	
+				case 'n':
+					db_printf("%5d  %5d  %5d  %d  %#10x  "
+					    "%-12.12s  %-16s\n",
+					    pp ? pp->p_pid : -1, p->p_pgrp->pg_id,
+					    p->p_cred->p_ruid, p->p_stat, p->p_flag,
+					    (p->p_wchan && p->p_wmesg) ?
+						p->p_wmesg : "", p->p_comm);
+					break;
+	
+				case 'w':
+					db_printf("%-16s  %-8s  %18p  %s\n", p->p_comm,
+					    p->p_emul->e_name, p->p_wchan,
+					    (p->p_wchan && p->p_wmesg) ? 
+						p->p_wmesg : "");
+					break;
+	
+				}
+			}
+			p = LIST_NEXT(p, p_list);
+			if (p == 0 && doingzomb == 0) {
+				doingzomb = 1;
+				p = LIST_FIRST(&i->inst_proc->zombproc);
 			}
-		}
-		p = LIST_NEXT(p, p_list);
-		if (p == 0 && doingzomb == 0) {
-			doingzomb = 1;
-			p = LIST_FIRST(&zombproc);
 		}
 	}
 }
 #endif
 
-#ifdef DEBUG
+
 void
-pgrpdump(void)
+pgrpinit(struct proc *p1, struct proc *p2)
 {
-	struct pgrp *pgrp;
-	struct proc *p;
-	int i;
+	struct pgrp	*pgrp;
+	struct session	*sess;
 
-	for (i = 0; i <= pgrphash; i++) {
-		if (!LIST_EMPTY(&pgrphashtbl[i])) {
-			printf("\tindx %d\n", i);
-			LIST_FOREACH(pgrp, &pgrphashtbl[i], pg_hash) {
-				printf("\tpgrp %p, pgid %d, sess %p, sesscnt %d, mem %p\n",
-				    pgrp, pgrp->pg_id, pgrp->pg_session,
-				    pgrp->pg_session->s_count,
-				    LIST_FIRST(&pgrp->pg_members));
-				LIST_FOREACH(p, &pgrp->pg_members, p_pglist) {
-					printf("\t\tpid %d addr %p pgrp %p\n", 
-					    p->p_pid, p, p->p_pgrp);
-				}
-			}
-		}
-	}
+	KASSERT(p1);
+	KASSERT(p2);
+
+	pgrp = pool_get(&pgrp_pool, PR_WAITOK | PR_ZERO);
+	sess = pool_get(&session_pool, PR_WAITOK | PR_ZERO);
+
+	bcopy(p1->p_session->s_login, 
+			sess->s_login, sizeof(sess->s_login));
+
+	sess->s_count = 1;
+	sess->s_leader = NULL;
+
+	pgrp->pg_session = sess;
+	p2->p_pgrp = pgrp;
+
+	pgrp_instadd(p2->p_inst->inst_proc, pgrp);
+#ifdef GLOBAL_HASH
+	pgrp->pg_inst = p2->p_inst;
+#endif
+	enterpgrp(p2, p2->p_pid, 1);
 }
-#endif /* DEBUG */
Index: kern/kern_prot.c
===================================================================
RCS file: /cvs/OpenBSD/src/sys/kern/kern_prot.c,v
retrieving revision 1.31
retrieving revision 1.31.4.6
diff -u -r1.31 -r1.31.4.6
--- kern/kern_prot.c	22 May 2008 21:27:40 -0000	1.31
+++ kern/kern_prot.c	13 Feb 2009 09:08:59 -0000	1.31.4.6
@@ -63,7 +63,8 @@
 	*retval = p->p_p->ps_mainproc->p_pid;
 #if defined(COMPAT_43) || defined(COMPAT_SUNOS) || defined(COMPAT_IBCS2) || \
     defined(COMPAT_FREEBSD) || defined(COMPAT_BSDOS)
-	retval[1] = p->p_p->ps_mainproc->p_pptr->p_pid;
+	retval[1] = p->p_p->ps_mainproc->p_pptr ? 
+		p->p_p->ps_mainproc->p_pptr->p_pid : -1;
 #endif
 	return (0);
 }
@@ -87,7 +88,8 @@
 sys_getppid(struct proc *p, void *v, register_t *retval)
 {
 
-	*retval = p->p_p->ps_mainproc->p_pptr->p_pid;
+	*retval = p->p_p->ps_mainproc->p_pptr ?
+		p->p_p->ps_mainproc->p_pptr->p_pid : -1;
 	return (0);
 }
 
@@ -113,7 +115,7 @@
 
 	if (SCARG(uap, pid) == 0 || SCARG(uap, pid) == curp->p_pid)
 		goto found;
-	if ((targp = pfind(SCARG(uap, pid))) == NULL)
+	if ((targp = pfind(curp->p_inst->inst_proc, SCARG(uap, pid))) == NULL)
 		return (ESRCH);
 	if (targp->p_session != curp->p_session)
 		return (EPERM);
@@ -132,7 +134,7 @@
 
 	if (SCARG(uap, pid) == 0 || SCARG(uap, pid) == curp->p_pid)
 		goto found;
-	if ((targp = pfind(SCARG(uap, pid))) == NULL)
+	if ((targp = pfind(curp->p_inst->inst_proc, SCARG(uap, pid))) == NULL)
 		return (ESRCH);
 	if (targp->p_session != curp->p_session)
 		return (EPERM);
@@ -234,7 +236,7 @@
 sys_setsid(struct proc *p, void *v, register_t *retval)
 {
 
-	if (p->p_pgid == p->p_pid || pgfind(p->p_pid)) {
+	if (p->p_pgid == p->p_pid || pgfind(p->p_inst->inst_proc, p->p_pid)) {
 		return (EPERM);
 	} else {
 		(void)enterpgrp(p, p->p_pid, 1);
@@ -276,7 +278,7 @@
 		return (EINVAL);
 
 	if (pid != 0 && pid != curp->p_pid) {
-		if ((targp = pfind(pid)) == 0 || !inferior(targp))
+		if ((targp = pfind(curp->p_inst->inst_proc, pid)) == 0 || !inferior(targp))
 			return (ESRCH);
 		if (targp->p_session != curp->p_session)
 			return (EPERM);
@@ -289,7 +291,7 @@
 	if (pgid == 0)
 		pgid = targp->p_pid;
 	else if (pgid != targp->p_pid)
-		if ((pgrp = pgfind(pgid)) == 0 ||
+		if ((pgrp = pgfind(curp->p_inst->inst_proc, pgid)) == 0 ||
 		    pgrp->pg_session != curp->p_session)
 			return (EPERM);
 	return (enterpgrp(targp, pgid, 0));
@@ -766,16 +768,36 @@
 	return (EPERM);
 }
 
+
 /*
  * Allocate a zeroed cred structure.
  */
 struct ucred *
-crget(void)
+crnew(void)
 {
 	struct ucred *cr;
 
 	cr = pool_get(&ucred_pool, PR_WAITOK|PR_ZERO);
 	cr->cr_ref = 1;
+
+	return (cr);
+}
+
+/*
+ * Allocate a zeroed cred structure.
+ */
+struct ucred *
+crget(struct inst *inst)
+{
+	struct ucred *cr;
+
+	KASSERT(inst);
+
+	cr = pool_get(&ucred_pool, PR_WAITOK|PR_ZERO);
+	cr->cr_ref = 1;
+	cr->cr_inst = inst;
+
+	insthold(cr->cr_inst);
 	return (cr);
 }
 
@@ -787,8 +809,10 @@
 crfree(struct ucred *cr)
 {
 
-	if (--cr->cr_ref == 0)
+	if (--cr->cr_ref == 0) {
+		instfree(cr->cr_inst);
 		pool_put(&ucred_pool, cr);
+	}
 }
 
 /*
@@ -801,7 +825,7 @@
 
 	if (cr->cr_ref == 1)
 		return (cr);
-	newcr = crget();
+	newcr = crget(cr->cr_inst);
 	*newcr = *cr;
 	crfree(cr);
 	newcr->cr_ref = 1;
@@ -816,7 +840,7 @@
 {
 	struct ucred *newcr;
 
-	newcr = crget();
+	newcr = crget(cr->cr_inst);
 	*newcr = *cr;
 	newcr->cr_ref = 1;
 	return (newcr);
Index: kern/kern_resource.c
===================================================================
RCS file: /cvs/OpenBSD/src/sys/kern/kern_resource.c,v
retrieving revision 1.33
retrieving revision 1.33.4.6
diff -u -r1.33 -r1.33.4.6
--- kern/kern_resource.c	22 May 2008 17:04:59 -0000	1.33
+++ kern/kern_resource.c	27 Sep 2008 14:09:44 -0000	1.33.4.6
@@ -77,7 +77,7 @@
 		if (SCARG(uap, who) == 0)
 			p = curp;
 		else
-			p = pfind(SCARG(uap, who));
+			p = pfind(curp->p_inst->inst_proc, SCARG(uap, who));
 		if (p == 0)
 			break;
 		low = p->p_nice;
@@ -88,7 +88,7 @@
 
 		if (SCARG(uap, who) == 0)
 			pg = curp->p_pgrp;
-		else if ((pg = pgfind(SCARG(uap, who))) == NULL)
+		else if ((pg = pgfind(curp->p_inst->inst_proc, SCARG(uap, who))) == NULL)
 			break;
 		LIST_FOREACH(p, &pg->pg_members, p_pglist) {
 			if (p->p_nice < low)
@@ -100,7 +100,7 @@
 	case PRIO_USER:
 		if (SCARG(uap, who) == 0)
 			SCARG(uap, who) = curp->p_ucred->cr_uid;
-		LIST_FOREACH(p, &allproc, p_list)
+		PROCLIST_FOREACH(p, curp, p_list)
 			if (p->p_ucred->cr_uid == SCARG(uap, who) &&
 			    p->p_nice < low)
 				low = p->p_nice;
@@ -133,7 +133,7 @@
 		if (SCARG(uap, who) == 0)
 			p = curp;
 		else
-			p = pfind(SCARG(uap, who));
+			p = pfind(curp->p_inst->inst_proc, SCARG(uap, who));
 		if (p == 0)
 			break;
 		error = donice(curp, p, SCARG(uap, prio));
@@ -145,7 +145,7 @@
 		 
 		if (SCARG(uap, who) == 0)
 			pg = curp->p_pgrp;
-		else if ((pg = pgfind(SCARG(uap, who))) == NULL)
+		else if ((pg = pgfind(curp->p_inst->inst_proc, SCARG(uap, who))) == NULL)
 			break;
 		LIST_FOREACH(p, &pg->pg_members, p_pglist) {
 			error = donice(curp, p, SCARG(uap, prio));
@@ -157,7 +157,7 @@
 	case PRIO_USER:
 		if (SCARG(uap, who) == 0)
 			SCARG(uap, who) = curp->p_ucred->cr_uid;
-		LIST_FOREACH(p, &allproc, p_list)
+		PROCLIST_FOREACH(p, curp, p_list)
 			if (p->p_ucred->cr_uid == SCARG(uap, who)) {
 				error = donice(curp, p, SCARG(uap, prio));
 				found++;
@@ -417,8 +417,10 @@
 	}
 
 	newlim = pool_get(&plimit_pool, PR_WAITOK);
+
 	bcopy(lim->pl_rlimit, newlim->pl_rlimit,
-	    sizeof(struct rlimit) * RLIM_NLIMITS);
+			sizeof(struct rlimit) * RLIM_NLIMITS);
+
 	newlim->p_lflags = 0;
 	newlim->p_refcnt = 1;
 	return (newlim);
Index: kern/kern_sig.c
===================================================================
RCS file: /cvs/OpenBSD/src/sys/kern/kern_sig.c,v
retrieving revision 1.99
retrieving revision 1.99.4.11
diff -u -r1.99 -r1.99.4.11
--- kern/kern_sig.c	10 Jun 2008 20:41:52 -0000	1.99
+++ kern/kern_sig.c	18 Feb 2009 12:43:25 -0000	1.99.4.11
@@ -294,9 +294,12 @@
 		 * (init) which will reap the zombie.  Because we use
 		 * init to do our dirty work we never set P_NOCLDWAIT
 		 * for PID 1.
+		 *
+		 * Changed because init isn't necessarily process 1.
 		 */
-		if (p->p_pid != 1 && ((sa->sa_flags & SA_NOCLDWAIT) ||
-		    sa->sa_handler == SIG_IGN))
+		if (p == p->p_inst->inst_proc->initproc &&
+				((sa->sa_flags & SA_NOCLDWAIT) ||
+				 sa->sa_handler == SIG_IGN))
 			atomic_setbits_int(&p->p_flag, P_NOCLDWAIT);
 		else
 			atomic_clearbits_int(&p->p_flag, P_NOCLDWAIT);
@@ -578,7 +581,7 @@
 		return (EINVAL);
 	if (SCARG(uap, pid) > 0) {
 		/* kill single process */
-		if ((p = pfind(SCARG(uap, pid))) == NULL)
+		if ((p = pfind(cp->p_inst->inst_proc, SCARG(uap, pid))) == NULL)
 			return (ESRCH);
 		if (!cansignal(cp, pc, p, SCARG(uap, signum)))
 			return (EPERM);
@@ -613,9 +616,10 @@
 		/* 
 		 * broadcast
 		 */
-		LIST_FOREACH(p, &allproc, p_list) {
-			if (p->p_pid <= 1 || p->p_flag & P_SYSTEM || 
-			    p == cp || !cansignal(cp, pc, p, signum))
+		PROCLIST_FOREACH(p, cp, p_list) {
+			if (p->p_pid <= 1 || p == p->p_inst->inst_proc->initproc ||
+					p->p_flag & P_SYSTEM || p == cp ||
+					!cansignal(cp, pc, p, signum))
 				continue;
 			nfound++;
 			if (signum)
@@ -628,13 +632,14 @@
 			 */
 			pgrp = cp->p_pgrp;
 		else {
-			pgrp = pgfind(pgid);
+			pgrp = pgfind(cp->p_inst->inst_proc, pgid);
 			if (pgrp == NULL)
 				return (ESRCH);
 		}
 		LIST_FOREACH(p, &pgrp->pg_members, p_pglist) {
-			if (p->p_pid <= 1 || p->p_flag & P_SYSTEM ||
-			    !cansignal(cp, pc, p, signum))
+			if (p->p_pid <= 1 || p == p->p_inst->inst_proc->initproc ||
+					p->p_flag & P_SYSTEM || 
+					!cansignal(cp, pc, p, signum))
 				continue;
 			nfound++;
 			if (signum && P_ZOMBIE(p) == 0)
@@ -658,22 +663,31 @@
  * process and see if it is permitted.
  */
 void
-csignal(pid_t pgid, int signum, uid_t uid, uid_t euid)
+csignal(instid_t instid, pid_t pgid, int signum, uid_t uid, uid_t euid)
 {
 	struct pgrp *pgrp;
 	struct proc *p;
+	struct inst *inst;
 
 	if (pgid == 0)
 		return;
 	if (pgid < 0) {
 		pgid = -pgid;
-		if ((pgrp = pgfind(pgid)) == NULL)
+		inst = instkfind(instid);
+		if (NULL == inst)
+			return;
+		pgrp = pgfind(inst->inst_proc, pgid);
+		if (NULL == pgrp)
 			return;
 		LIST_FOREACH(p, &pgrp->pg_members, p_pglist)
 			if (CANDELIVER(uid, euid, p))
 				psignal(p, signum);
 	} else {
-		if ((p = pfind(pgid)) == NULL)
+		inst = instkfind(instid);
+		if (NULL == inst)
+			return;
+		p = pfind(inst->inst_proc, pgid);
+		if (NULL == p)
 			return;
 		if (CANDELIVER(uid, euid, p))
 			psignal(p, signum);
@@ -684,11 +698,19 @@
  * Send a signal to a process group.
  */
 void
-gsignal(int pgid, int signum)
+gsignal(instid_t instid, int pgid, int signum)
 {
 	struct pgrp *pgrp;
+	struct inst *inst;
+
+	if (0 == pgid)
+		return;
+
+	inst = instkfind(instid);
+	if (NULL == inst)
+		return;
 
-	if (pgid && (pgrp = pgfind(pgid)))
+	if ((pgrp = pgfind(inst->inst_proc, pgid)))
 		pgsignal(pgrp, signum, 0);
 }
 
@@ -999,8 +1021,10 @@
 	setrunnable(p);
 out:
 	SCHED_UNLOCK(s);
-	if (wakeparent)
+	if (wakeparent) {
+		KASSERT(p->p_pptr);
 		wakeup(p->p_pptr);
+	}
 }
 
 /*
@@ -1085,14 +1109,14 @@
 			/*
 			 * Don't take default actions on system processes.
 			 */
-			if (p->p_pid <= 1) {
+			if (p->p_pid <= 1 || p == p->p_inst->inst_proc->initproc) {
 #ifdef DIAGNOSTIC
 				/*
 				 * Are you sure you want to ignore SIGSEGV
 				 * in init? XXX
 				 */
-				printf("Process (pid %d) got signal %d\n",
-				    p->p_pid, signum);
+				printf("Process (pid %d, instid %u) got signal %d\n",
+				    p->p_pid, p->p_inst->inst_id, signum);
 #endif
 				break;		/* == ignore */
 			}
@@ -1194,15 +1218,20 @@
 proc_stop_sweep(void *v)
 {
 	struct proc *p;
+	struct inst *i;
 
-	LIST_FOREACH(p, &allproc, p_list) {
-		if ((p->p_flag & P_STOPPED) == 0)
-			continue;
-		atomic_clearbits_int(&p->p_flag, P_STOPPED);
-
-		if ((p->p_pptr->p_flag & P_NOCLDSTOP) == 0)
-			psignal(p->p_pptr, SIGCHLD);
-		wakeup(p->p_pptr);
+	LIST_FOREACH(i, &inst_all, inst_list) {
+		LIST_FOREACH(p, &i->inst_proc->allproc, p_list) {
+			if ((p->p_flag & P_STOPPED) == 0)
+				continue;
+			atomic_clearbits_int(&p->p_flag, P_STOPPED);
+			if (NULL == p->p_pptr)
+				/* FIXME: this shouldn't happen. */
+				continue;
+			if ((p->p_pptr->p_flag & P_NOCLDSTOP) == 0)
+				psignal(p->p_pptr, SIGCHLD);
+			wakeup(p->p_pptr);
+		}
 	}
 }
 
Index: kern/kern_sysctl.c
===================================================================
RCS file: /cvs/OpenBSD/src/sys/kern/kern_sysctl.c,v
retrieving revision 1.161
retrieving revision 1.161.4.7
diff -u -r1.161 -r1.161.4.7
--- kern/kern_sysctl.c	9 Jun 2008 07:07:16 -0000	1.161
+++ kern/kern_sysctl.c	18 Feb 2009 12:43:25 -0000	1.161.4.7
@@ -255,6 +255,7 @@
 		switch (name[0]) {
 		case KERN_PROC:
 		case KERN_PROC2:
+		case KERN_INSTPROC2:
 		case KERN_PROF:
 		case KERN_MALLOCSTATS:
 		case KERN_TTY:
@@ -271,6 +272,7 @@
 		case KERN_TIMECOUNTER:
 #endif
 		case KERN_CPTIME2:
+		case KERN_INST:
 			break;
 		default:
 			return (ENOTDIR);	/* overloaded */
@@ -341,10 +343,13 @@
 #ifndef SMALL_KERNEL
 	case KERN_PROC:
 	case KERN_PROC2:
-		return (sysctl_doproc(name, namelen, oldp, oldlenp));
+	case KERN_INSTPROC2:
+		return (sysctl_doproc(p, name, namelen, oldp, oldlenp));
 	case KERN_PROC_ARGS:
 		return (sysctl_proc_args(name + 1, namelen - 1, oldp, oldlenp,
 		     p));
+	case KERN_INST:
+		return (sysctl_doinst(p, name, namelen, oldp, oldlenp));
 #endif
 	case KERN_FILE:
 		return (sysctl_file(oldp, oldlenp));
@@ -977,19 +982,24 @@
 #define KERN_PROCSLOP	(5 * sizeof (struct kinfo_proc))
 
 int
-sysctl_doproc(int *name, u_int namelen, char *where, size_t *sizep)
+sysctl_doproc(struct proc *cp, int *name, 
+		u_int namelen, char *where, size_t *sizep)
 {
-	struct kinfo_proc2 *kproc2 = NULL;
-	struct eproc *eproc = NULL;
+	struct inst *inst;
+	struct kinfo_proc2 *kproc2;
+	struct eproc *eproc;
 	struct proc *p;
 	char *dp;
 	int arg, buflen, doingzomb, elem_size, elem_count;
 	int error, needed, type, op;
 
+	kproc2 = NULL;
+	eproc = NULL;
 	dp = where;
 	buflen = where != NULL ? *sizep : 0;
 	needed = error = 0;
 	type = name[0];
+	inst = cp->p_inst;
 
 	if (type == KERN_PROC) {
 		if (namelen != 3 && !(namelen == 2 &&
@@ -999,7 +1009,7 @@
 		arg = op == KERN_PROC_ALL ? 0 : name[2];
 		elem_size = elem_count = 0;
 		eproc = malloc(sizeof(struct eproc), M_TEMP, M_WAITOK);
-	} else /* if (type == KERN_PROC2) */ {
+	} else if (type == KERN_PROC2) {
 		if (namelen != 5 || name[3] < 0 || name[4] < 0)
 			return (EINVAL);
 		op = name[1];
@@ -1007,8 +1017,21 @@
 		elem_size = name[3];
 		elem_count = name[4];
 		kproc2 = malloc(sizeof(struct kinfo_proc2), M_TEMP, M_WAITOK);
+	} else /* if (type == KERN_INSTPROC2) */ {
+		if (namelen != 6 || name[4] < 0 || name[5] < 0)
+			return (EINVAL);
+		inst = instpfind(cp, name[1], INST_KPROC);
+		if (NULL == inst)
+			return (EINSTSRCH);
+
+		op = name[2];
+		arg = name[3];
+		elem_size = name[4];
+		elem_count = name[5];
+		kproc2 = malloc(sizeof(struct kinfo_proc2), M_TEMP, M_WAITOK);
 	}
-	p = LIST_FIRST(&allproc);
+
+	p = LIST_FIRST(&inst->inst_proc->allproc);
 	doingzomb = 0;
 again:
 	for (; p != 0; p = LIST_NEXT(p, p_list)) {
@@ -1104,7 +1127,7 @@
 		}
 	}
 	if (doingzomb == 0) {
-		p = LIST_FIRST(&zombproc);
+		p = LIST_FIRST(&cp->p_inst->inst_proc->zombproc);
 		doingzomb++;
 		goto again;
 	}
@@ -1128,6 +1151,7 @@
 
 #endif	/* SMALL_KERNEL */
 
+
 /*
  * Fill in an eproc structure for the specified process.
  */
@@ -1385,7 +1409,7 @@
 		return (EOPNOTSUPP);
 	}
 
-	if ((vp = pfind(pid)) == NULL)
+	if ((vp = pfind(cp->p_inst->inst_proc, pid)) == NULL)
 		return (ESRCH);
 
 	if (oldp == NULL) {
Index: kern/sched_bsd.c
===================================================================
RCS file: /cvs/OpenBSD/src/sys/kern/sched_bsd.c,v
retrieving revision 1.17
retrieving revision 1.17.4.3
diff -u -r1.17 -r1.17.4.3
--- kern/sched_bsd.c	18 Jul 2008 23:43:31 -0000	1.17
+++ kern/sched_bsd.c	18 Feb 2009 12:43:25 -0000	1.17.4.3
@@ -208,6 +208,7 @@
 {
 	struct timeout *to = (struct timeout *)arg;
 	fixpt_t loadfac = loadfactor(averunnable.ldavg[0]);
+	struct inst *i;
 	struct proc *p;
 	int s;
 	unsigned int newcpu;
@@ -222,50 +223,52 @@
 	phz = stathz ? stathz : profhz;
 	KASSERT(phz);
 
-	LIST_FOREACH(p, &allproc, p_list) {
-		/*
-		 * Increment time in/out of memory and sleep time
-		 * (if sleeping).  We ignore overflow; with 16-bit int's
-		 * (remember them?) overflow takes 45 days.
-		 */
-		p->p_swtime++;
-		if (p->p_stat == SSLEEP || p->p_stat == SSTOP)
-			p->p_slptime++;
-		p->p_pctcpu = (p->p_pctcpu * ccpu) >> FSHIFT;
-		/*
-		 * If the process has slept the entire second,
-		 * stop recalculating its priority until it wakes up.
-		 */
-		if (p->p_slptime > 1)
-			continue;
-		SCHED_LOCK(s);
-		/*
-		 * p_pctcpu is only for ps.
-		 */
-#if	(FSHIFT >= CCPU_SHIFT)
-		p->p_pctcpu += (phz == 100)?
-			((fixpt_t) p->p_cpticks) << (FSHIFT - CCPU_SHIFT):
-                	100 * (((fixpt_t) p->p_cpticks)
-				<< (FSHIFT - CCPU_SHIFT)) / phz;
-#else
-		p->p_pctcpu += ((FSCALE - ccpu) *
-			(p->p_cpticks * FSCALE / phz)) >> FSHIFT;
-#endif
-		p->p_cpticks = 0;
-		newcpu = (u_int) decay_cpu(loadfac, p->p_estcpu);
-		p->p_estcpu = newcpu;
-		resetpriority(p);
-		if (p->p_priority >= PUSER) {
-			if ((p != curproc) &&
-			    p->p_stat == SRUN &&
-			    (p->p_priority / PPQ) != (p->p_usrpri / PPQ)) {
-				remrunqueue(p);
-				p->p_priority = p->p_usrpri;
-				setrunqueue(p);
-			} else
-				p->p_priority = p->p_usrpri;
+	LIST_FOREACH(i, &inst_all, inst_list) {
+		LIST_FOREACH(p, &i->inst_proc->allproc, p_list) {
+			/*
+			 * Increment time in/out of memory and sleep time
+			 * (if sleeping).  We ignore overflow; with 16-bit int's
+			 * (remember them?) overflow takes 45 days.
+			 */
+			p->p_swtime++;
+			if (p->p_stat == SSLEEP || p->p_stat == SSTOP)
+				p->p_slptime++;
+			p->p_pctcpu = (p->p_pctcpu * ccpu) >> FSHIFT;
+			/*
+			 * If the process has slept the entire second,
+			 * stop recalculating its priority until it wakes up.
+			 */
+			if (p->p_slptime > 1)
+				continue;
+			SCHED_LOCK(s);
+			/*
+			 * p_pctcpu is only for ps.
+			 */
+	#if	(FSHIFT >= CCPU_SHIFT)
+			p->p_pctcpu += (phz == 100)?
+				((fixpt_t) p->p_cpticks) << (FSHIFT - CCPU_SHIFT):
+	                	100 * (((fixpt_t) p->p_cpticks)
+					<< (FSHIFT - CCPU_SHIFT)) / phz;
+	#else
+			p->p_pctcpu += ((FSCALE - ccpu) *
+				(p->p_cpticks * FSCALE / phz)) >> FSHIFT;
+	#endif
+			p->p_cpticks = 0;
+			newcpu = (u_int) decay_cpu(loadfac, p->p_estcpu);
+			p->p_estcpu = newcpu;
+			resetpriority(p);
+			if (p->p_priority >= PUSER) {
+				if ((p != curproc) &&
+				    p->p_stat == SRUN &&
+				    (p->p_priority / PPQ) != (p->p_usrpri / PPQ)) {
+					remrunqueue(p);
+					p->p_priority = p->p_usrpri;
+					setrunqueue(p);
+				} else
+					p->p_priority = p->p_usrpri;
+			}
+			SCHED_UNLOCK(s);
 		}
-		SCHED_UNLOCK(s);
 	}
 	uvm_meter();
 	wakeup(&lbolt);
Index: kern/subr_log.c
===================================================================
RCS file: /cvs/OpenBSD/src/sys/kern/subr_log.c,v
retrieving revision 1.15
retrieving revision 1.15.6.2
diff -u -r1.15 -r1.15.6.2
--- kern/subr_log.c	3 Sep 2007 17:51:03 -0000	1.15
+++ kern/subr_log.c	20 Sep 2008 00:09:45 -0000	1.15.6.2
@@ -58,6 +58,7 @@
 	struct	selinfo sc_selp;	/* process waiting on select call */
 	int	sc_pgid;		/* process/group for async I/O */
 	uid_t	sc_siguid;		/* uid for process that set sc_pgid */
+	instid_t sc_siginstid;		/* instid for process that set sc_pgid */
 	uid_t	sc_sigeuid;		/* euid for process that set sc_pgid */
 } logsoftc;
 
@@ -257,7 +258,7 @@
 		return;
 	selwakeup(&logsoftc.sc_selp);
 	if (logsoftc.sc_state & LOG_ASYNC)
-		csignal(logsoftc.sc_pgid, SIGIO,
+		csignal(logsoftc.sc_siginstid, logsoftc.sc_pgid, SIGIO,
 		    logsoftc.sc_siguid, logsoftc.sc_sigeuid);
 	if (logsoftc.sc_state & LOG_RDWAIT) {
 		wakeup(msgbufp);
@@ -298,6 +299,7 @@
 	case TIOCSPGRP:
 		logsoftc.sc_pgid = *(int *)data;
 		logsoftc.sc_siguid = p->p_cred->p_ruid;
+		logsoftc.sc_siginstid = p->p_inst->inst_id;
 		logsoftc.sc_sigeuid = p->p_ucred->cr_uid;
 		break;
 
Index: kern/sys_generic.c
===================================================================
RCS file: /cvs/OpenBSD/src/sys/kern/sys_generic.c,v
retrieving revision 1.58
retrieving revision 1.58.6.5
diff -u -r1.58 -r1.58.6.5
--- kern/sys_generic.c	7 Sep 2007 15:00:20 -0000	1.58
+++ kern/sys_generic.c	18 Feb 2009 12:43:25 -0000	1.58.6.5
@@ -564,6 +564,7 @@
 
 			so->so_pgid = tmp;
 			so->so_siguid = p->p_cred->p_ruid;
+			so->so_siginstid = p->p_inst->inst_id;
 			so->so_sigeuid = p->p_ucred->cr_uid;
 			error = 0;
 			break;
@@ -571,7 +572,7 @@
 		if (tmp <= 0) {
 			tmp = -tmp;
 		} else {
-			struct proc *p1 = pfind(tmp);
+			struct proc *p1 = pfind(p->p_inst->inst_proc, tmp);
 			if (p1 == 0) {
 				error = ESRCH;
 				break;
@@ -782,15 +783,20 @@
 {
 	struct proc *p;
 	pid_t mypid;
+	instid_t myinst;
 
 	mypid = selector->p_pid;
-	if (sip->si_selpid == mypid)
+	myinst = selector->p_inst->inst_id;
+
+	if (sip->si_selpid == mypid && sip->si_selinst == myinst)
 		return;
-	if (sip->si_selpid && (p = pfind(sip->si_selpid)) &&
+	if (sip->si_selpid && (p = pfind(selector->p_inst->inst_proc, sip->si_selpid)) &&
 	    p->p_wchan == (caddr_t)&selwait)
 		sip->si_flags |= SI_COLL;
-	else
+	else {
 		sip->si_selpid = mypid;
+		sip->si_selinst = myinst;
+	}
 }
 
 /*
@@ -800,6 +806,7 @@
 selwakeup(struct selinfo *sip)
 {
 	struct proc *p;
+	struct inst *inst;
 	int s;
 
 	if (sip->si_selpid == 0)
@@ -809,8 +816,14 @@
 		sip->si_flags &= ~SI_COLL;
 		wakeup(&selwait);
 	}
-	p = pfind(sip->si_selpid);
+
+	inst = instkfind(sip->si_selinst);
+	if (NULL == inst)
+		return;
+
+	p = pfind(inst->inst_proc, sip->si_selpid);
 	sip->si_selpid = 0;
+
 	if (p != NULL) {
 		SCHED_LOCK(s);
 		if (p->p_wchan == (caddr_t)&selwait) {
